/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F1825
        Driver Version    :  2.00

  DRV8835 FUNCTION TABLE (x:A/B)
    FUNTION      xENABLE     xPHASE       xOUT1       xOUT2 
    Brake           0           X           L           L 
    Reverse         1           1           L           H
    Forward         1           0           H           L

*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

#define B_ENABLE RC0    // RC0sBIN2:BENABLE
#define B_PHASE RC1     // RC1sBIN1:BPHASE
#define A_ENABLE RC2    // RC2sAIN2:AENABLE
#define A_PHASE RC3     // RC3sAIN1:APHASE

#define SW1 RA4         // RA4sCW(v)XCb`
#define SW2 RA5         // RA5sCCW(v)XCb`

// O[oϐ錾
unsigned long result;   // ADϊʊi[ϐ

// vg^CsO錾
void CW1(void);     // 1㎥CW] 
void CCW1(void);    // 1㎥CCW
void CW2(void);     // 2㎥CW] 
void CCW2(void);    // 2㎥CCW]
void CW12(void);    // 1-2㎥CW] 
void CCW12(void);   // 1-2㎥CCW]
void Delay_Wait(void);   // pX 

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        // Add your application code
        
        result = ADC_GetConversion(channel_AN0);     // AN0_ADϊ(10rbg)擾        
        
        A_ENABLE = B_ENABLE = 0;      // u[L        
        
        while (SW1 == 0)    // SW1 ON̊
//            CW1();   // 1㎥_v
            CW2();   // 2㎥_v
//            CW12();   // 1-2㎥_v
        
        while (SW2 == 0)    // SW2 ON̊
//            CCW1();   // 1㎥_v
            CCW2();   // 2㎥_v
//            CCW12();   // 1-2㎥_v
       
    }
}

// 1㎥
void CW1(void)       // v              
{
    LATC = 0x04;
        Delay_Wait();
    LATC = 0x01;
        Delay_Wait();
    LATC = 0x0C;
        Delay_Wait();        
    LATC = 0x03;
        Delay_Wait();
}    

void CCW1(void)      // v              
{
    LATC = 0x03;
        Delay_Wait();
    LATC = 0x0C;
        Delay_Wait();
    LATC = 0x01;
        Delay_Wait();        
    LATC = 0x04;
        Delay_Wait();
}

// 2㎥
void CW2(void)       // v              
{
    LATC = 0x07;
        Delay_Wait();
    LATC = 0x05;
        Delay_Wait();
    LATC = 0x0D;
        Delay_Wait();        
    LATC = 0x0F;
        Delay_Wait();
}    

void CCW2(void)      // v              
{
    LATC = 0x0F;
        Delay_Wait();
    LATC = 0x0D;
        Delay_Wait();
    LATC = 0x05;
        Delay_Wait();        
    LATC = 0x07;
        Delay_Wait();
}

// 1-2㎥
void CW12(void)       // v              
{
    LATC = 0x07;
        Delay_Wait();
    LATC = 0x04;
        Delay_Wait();
    LATC = 0x05;
        Delay_Wait();        
    LATC = 0x01;
        Delay_Wait();
    LATC = 0x0D;
        Delay_Wait();
    LATC = 0x0C;
        Delay_Wait();
    LATC = 0x0F;
        Delay_Wait();        
    LATC = 0x03;
        Delay_Wait();    
}    

void CCW12(void)      // v              
{
    LATC = 0x03;
        Delay_Wait();
    LATC = 0x0F;
        Delay_Wait();
    LATC = 0x0C;
        Delay_Wait();        
    LATC = 0x0D;
        Delay_Wait();
    LATC = 0x01;
        Delay_Wait();
    LATC = 0x05;
        Delay_Wait();
    LATC = 0x04;
        Delay_Wait();        
    LATC = 0x07;
        Delay_Wait();    
}

void Delay_Wait(void)      // pX 
{
    unsigned long i;

    for(i=0; i<result; i++)      //      
    __delay_us(1);    
}

/**
 End of File
*/